import { PropertySchema } from '@deepkit/type';
export declare class ConfigOption {
    name: string;
    type: string;
    defaultValue: any;
    value: any;
    description?: string;
}
export declare class Config {
    appConfig: ConfigOption[];
    modulesConfig: ConfigOption[];
}
export declare class RouteParameter {
    name: string;
    type: 'body' | 'query' | 'url';
    schema: any;
}
export declare class Route {
    path: string;
    httpMethod: string;
    controller: string;
    description: string;
    parameters: RouteParameter[];
    bodySchema?: any;
    bodyPropertySchema?: PropertySchema;
    constructor(path: string, httpMethod: string, controller: string, description: string, parameters: RouteParameter[], bodySchema?: any);
}
export declare class RpcActionParameter {
    name: string;
    schema: any;
    propertySchema: PropertySchema;
    constructor(name: string, schema: any);
}
export declare class RpcAction {
    path: string;
    controller: string;
    methodName: string;
    parameters: RpcActionParameter[];
}
export declare const DebugControllerSymbol: import("@deepkit/framework-shared").ControllerDefinition<DebugControllerInterface>;
export interface DebugControllerInterface {
    configuration(): Config;
    routes(): Route[];
    actions(): RpcAction[];
}
