"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DebugControllerSymbol = exports.RpcAction = exports.RpcActionParameter = exports.Route = exports.RouteParameter = exports.Config = exports.ConfigOption = void 0;
const type_1 = require("@deepkit/type");
const framework_shared_1 = require("@deepkit/framework-shared");
class ConfigOption {
}
__decorate([
    type_1.t,
    __metadata("design:type", String)
], ConfigOption.prototype, "name", void 0);
__decorate([
    type_1.t,
    __metadata("design:type", String)
], ConfigOption.prototype, "type", void 0);
__decorate([
    type_1.t.any,
    __metadata("design:type", Object)
], ConfigOption.prototype, "defaultValue", void 0);
__decorate([
    type_1.t.any,
    __metadata("design:type", Object)
], ConfigOption.prototype, "value", void 0);
__decorate([
    type_1.t.optional,
    __metadata("design:type", String)
], ConfigOption.prototype, "description", void 0);
exports.ConfigOption = ConfigOption;
let Config = class Config {
};
__decorate([
    type_1.t.array(ConfigOption),
    __metadata("design:type", Array)
], Config.prototype, "appConfig", void 0);
__decorate([
    type_1.t.array(ConfigOption),
    __metadata("design:type", Array)
], Config.prototype, "modulesConfig", void 0);
Config = __decorate([
    type_1.entity.name('debug/config')
], Config);
exports.Config = Config;
class RouteParameter {
}
__decorate([
    type_1.t,
    __metadata("design:type", String)
], RouteParameter.prototype, "name", void 0);
__decorate([
    type_1.t.string,
    __metadata("design:type", String)
], RouteParameter.prototype, "type", void 0);
__decorate([
    type_1.t.any,
    __metadata("design:type", Object)
], RouteParameter.prototype, "schema", void 0);
exports.RouteParameter = RouteParameter;
let Route = class Route {
    constructor(
    // @t public path: string,
    path, httpMethod, controller, description, parameters, bodySchema) {
        this.path = path;
        this.httpMethod = httpMethod;
        this.controller = controller;
        this.description = description;
        this.parameters = parameters;
        this.bodySchema = bodySchema;
        if (bodySchema) {
            this.bodyPropertySchema = type_1.PropertySchema.fromJSON(bodySchema);
        }
    }
};
Route = __decorate([
    type_1.entity.name('debug/route'),
    __param(0, type_1.t),
    __param(1, type_1.t),
    __param(2, type_1.t),
    __param(3, type_1.t),
    __param(4, type_1.t.array(RouteParameter)),
    __param(5, type_1.t.any),
    __metadata("design:paramtypes", [String, String, String, String, Array, Object])
], Route);
exports.Route = Route;
let RpcActionParameter = class RpcActionParameter {
    constructor(name, schema) {
        this.name = name;
        this.schema = schema;
        this.propertySchema = type_1.PropertySchema.fromJSON(schema);
    }
};
RpcActionParameter = __decorate([
    type_1.entity.name('rpc/action/parameter'),
    __param(0, type_1.t),
    __param(1, type_1.t.any),
    __metadata("design:paramtypes", [String, Object])
], RpcActionParameter);
exports.RpcActionParameter = RpcActionParameter;
let RpcAction = class RpcAction {
};
__decorate([
    type_1.t,
    __metadata("design:type", String)
], RpcAction.prototype, "path", void 0);
__decorate([
    type_1.t,
    __metadata("design:type", String)
], RpcAction.prototype, "controller", void 0);
__decorate([
    type_1.t,
    __metadata("design:type", String)
], RpcAction.prototype, "methodName", void 0);
__decorate([
    type_1.t.array(RpcActionParameter),
    __metadata("design:type", Array)
], RpcAction.prototype, "parameters", void 0);
RpcAction = __decorate([
    type_1.entity.name('rpc/action')
], RpcAction);
exports.RpcAction = RpcAction;
exports.DebugControllerSymbol = framework_shared_1.ControllerSymbol('debug/controller');
//# sourceMappingURL=api.js.map